using CommunityToolkit.Mvvm.ComponentModel;

using LibS7Adv;
using System.ComponentModel;
using System.Windows;
using System.Windows.Controls;
using CtrEditor.FuncionesBase;

namespace CtrEditor.ObjetosSim
{
    /// <summary>
    /// Interaction logic for ucSensTemperatura.xaml
    /// </summary>
    public partial class osSensTemperatura : osBase, IosBase
    {
        public static string NombreCategoria() => "SensoresComandos";
        // Otros datos y métodos relevantes para la simulación

        public static string NombreClase()
        {
            return "Sensor de Temperatura";
        }
        private string nombre = NombreClase();

        [property: Category("Identificación")]
        [property: Description("Nombre identificativo del objeto")]
        [property: Name("Nombre")]
        public override string Nombre
        {
            get => nombre;
            set => SetProperty(ref nombre, value);
        }

        [ObservableProperty]
        [property: Category("Enlace PLC")]
        [property: Description("Tag PLC para valor de temperatura")]
        [property: Name("Tag PLC")]
        public string tag;

        [ObservableProperty]
        [property: Category("Enlace PLC")]
        [property: Description("Valor mínimo escalado")]
        [property: Name("Mínimo Escalado")]
        public float min_OUT_Scaled;

        [ObservableProperty]
        [property: Category("Enlace PLC")]
        [property: Description("Valor máximo escalado")]
        [property: Name("Máximo Escalado")]
        public float max_OUT_Scaled;

        [ObservableProperty]
        [property: Category("Simulación")]
        [property: Description("Valor actual de temperatura")]
        [property: Name("Temperatura")]
        public float value;

        partial void OnValueChanged(float value)
        {
            EscribirWordTagScaled(Tag, value, 0, 100, Min_OUT_Scaled, Max_OUT_Scaled);
        }

        public osSensTemperatura()
        {
            Ancho = 0.4f;
            Alto = 1f;
            Max_OUT_Scaled = 27648;
            Min_OUT_Scaled = 0;
        }

        public override void UpdatePLC(PLCViewModel plc, int elapsedMilliseconds)
        {

        }
        public override void UpdatePLCPrimerCiclo()
        {
            // Escribimos el valor actual al iniciar la conexion
            OnValueChanged(Value);
        }

        public override void ucLoaded()
        {
            // El UserControl ya se ha cargado y podemos obtener las coordenadas para 
            // crear el objeto de simulacion
            base.ucLoaded();

        }

    }

    public partial class ucSensTemperatura : UserControl, IDataContainer
    {
        public osBase? Datos { get; set; }
        public int zIndex_fromFrames { get; set; }

        public ucSensTemperatura()
        {
            InitializeComponent();
            this.Loaded += OnLoaded;
            this.Unloaded += OnUnloaded;
        }
        private void OnLoaded(object sender, RoutedEventArgs e)
        {
            Datos?.ucLoaded();
        }
        private void OnUnloaded(object sender, RoutedEventArgs e)
        {
            Datos?.ucUnLoaded();
        }
        public void Highlight(bool State) { }
        public ZIndexEnum ZIndex_Base()
        {
            return ZIndexEnum.Estaticos;
        }

    }
}
